<?xml version="1.0" encoding="utf-8"?>
<!-- <?xml version="1.0" encoding="Shift_JIS"?> -->
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:dc='http://purl.org/dc/elements/1.1/'
	xmlns:upnp='urn:schemas-upnp-org:metadata-1-0/upnp/'
	xmlns:didl-lite='urn:schemas-upnp-org:metadata-1-0/DIDL-Lite/'
	xmlns:av='urn:schemas-sony-com:av'
>
<xsl:output method="html" encoding="utf-8" />
<!-- <xsl:output method="html" encoding="Shift_JIS" /> -->

<xsl:template match="/">
<html>
<head>
<title>ContentDirectory:1#Browse</title>
<style type="text/css">
	<![CDATA[
	a{text-decoration: none;}
	a:hover{background-color: #bbbbbb;}
	]]>
</style>
<script language="JavaScript">
	<![CDATA[
	var objXml = document.XMLDocument;
	var objXsl = document.XSLDocument;
	var nodSrt = objXsl.selectSingleNode("//xsl:sort");
	var prevKey = '';
	var order = 0;
	function sort(key, type) {
		if( key != '' ) {
			nodSrt.setAttribute("select", key);
		} else {
			nodSrt.setAttribute("select", "@id");
			order = 1;
		}
		if( type == 0 ) {
			nodSrt.setAttribute("data-type", "text");
		} else {
			nodSrt.setAttribute("data-type", "number");
		}
		if( prevKey != key || order != 0 ) {
			nodSrt.setAttribute("order", "descending");
			order = 0;
		} else {
			nodSrt.setAttribute("order", "ascending");
			order = 1;
		}
		sortList.innerHTML=objXml.documentElement.transformNode(objXsl);
		prevKey = key;
	}
	]]>
</script>
</head>
<body bgcolor="#dddddd">
<div id="sortList">
<xsl:apply-templates select="items"/>
</div>
</body>
</html>
</xsl:template>

<xsl:template match="items">
	<xsl:call-template name="DIDL-Lite"/>
	<p/>
	<xsl:apply-templates select="http"/>
</xsl:template>

<xsl:template name="DIDL-Lite">
	<form>
	<font size="+2"><i><xsl:value-of select="unit_info"/></i></font>
	<table cellspacing="1" cellpadding="3" border="0" bgcolor="#aaaaaa">
		<tr bgcolor="#eeeeee">
			<td><input type="button" value="No"       onClick="sort('', 0)"/></td>
			<td><input type="button" value="Title"    onClick="sort('dc:title', 0)"/></td>
			<td><input type="button" value="Size"     onClick="sort('didl-lite:res/@size', 1)"/></td>
			<td><input type="button" value="Channel"  onClick="sort('upnp:channelName', 0)"/></td>
			<td><input type="button" value="Start"    onClick="sort('av:recordStartDateTime', 0)"/></td>
			<td><input type="button" value="Duration" onClick="sort('didl-lite:res/@duration', 0)"/></td>
			<td><input type="button" value="bps"      onClick="sort('didl-lite:res/@bitrate', 1)"/></td>
			<td><input type="button" value="Max"      onClick="sort('didl-lite:res/@av:maxBitrate', 1)"/></td>

			<td><input type="button" value="Video"    onClick="sort('didl-lite:res/@resolution', 0)"/></td>
			<td><input type="button" value="Rate"     onClick="sort('didl-lite:res/@av:videoFrameRate', 1)"/></td>
			<td><input type="button" value="Freq"     onClick="sort('didl-lite:res/@sampleFrequency', 1)"/></td>
<!--
			<td><input type="button" value="Ch"       onClick="sort('didl-lite:res/@nrAudioChannels', 1)"/></td>
			<td><input type="button" value="Codec"    onClick="sort('didl-lite:res/@av:codec', 0)"/></td>
			<td><input type="button" value="Mode"     onClick="sort('didl-lite:res/@av:bitrateMode', 0)"/></td>
-->
		</tr>
		<xsl:for-each select="//didl-lite:item">
			<xsl:sort select="/"/>
			<tr bgcolor="#ffffff">
				<td nowrap="nowrap" align="center">
					<xsl:number value="position()" format="1"/>
				</td>
				<td>
					<a>
						<xsl:attribute name="href"><xsl:value-of select="didl-lite:res"/></xsl:attribute>
						<xsl:value-of select="dc:title"/>
					</a>
				</td>
				<td nowrap="nowrap" align="right">
					<xsl:value-of select="format-number(didl-lite:res/@size,'#,###')"/>
					<!--
					<xsl:value-of select="format-number((didl-lite:res/@size) div 1024 div 1024, '#,###.0')"/>MB
					-->
				</td>
				<td nowrap="nowrap">
					<xsl:value-of select="upnp:channelName"/>
				</td>
				<td nowrap="nowrap">
					<xsl:value-of select="substring(av:recordStartDateTime,1,10)"/>_
					<xsl:value-of select="substring(av:recordStartDateTime,12,8)"/>
				</td>
				<td nowrap="nowrap" align="center">
					<xsl:value-of select="substring(didl-lite:res/@duration,1,8)"/>
				</td>
				<td nowrap="nowrap">
					<xsl:value-of select="format-number((didl-lite:res/@bitrate) div 125000, '#,###.0')"/>M
				</td>
				<td nowrap="nowrap">
					<xsl:value-of select="format-number((didl-lite:res/@av:maxBitrate) div 125000, '#,###.0')"/>M
				</td>

				<td nowrap="nowrap">
					<xsl:value-of select="didl-lite:res/@resolution"/>
				</td>
				<td nowrap="nowrap">
					<xsl:value-of select="didl-lite:res/@av:videoFrameRate"/>f
				</td>
				<td nowrap="nowrap">
					<xsl:value-of select="format-number((didl-lite:res/@sampleFrequency) div 1000, '#.###')"/>kHz
				</td>
<!--
				<td nowrap="nowrap">
					<xsl:value-of select="didl-lite:res/@nrAudioChannels"/>
				</td>
				<td nowrap="nowrap">
					<xsl:value-of select="didl-lite:res/@av:codec"/>
				</td>
				<td nowrap="nowrap">
					<xsl:value-of select="didl-lite:res/@av:bitrateMode"/>
				</td>
-->
			</tr>
		</xsl:for-each>
	</table>
	</form>
</xsl:template>

<xsl:template match="http">
	<table cellspacint="1" cellpadding="3" border="0" bgcolor="#aaaaaa">
		<tr bgcolor="#eeeeee">
			<td>
				<pre><xsl:value-of select="request_header"/></pre>
				<pre><xsl:value-of select="response_header"/></pre>
			</td>
		</tr>
	</table>
</xsl:template>

</xsl:stylesheet>

