#!/usr/bin/perl
use Socket;

$CoCoon_IP      = '192.168.1.77';
$CoCoon_PORT    = 51001;
$LOCAL_PORT     = 5129;
$CGIMODE        = 1;
#$STYLESHEET     = './CCBrowse_list.xsl';
$STYLESHEET     = './CCBrowse.xsl';
$REQUEST        = './CCBrowse.xml';
$HOSTNAME       = 'unknown';
$SETTING        = "./CCBrowse_httpd.ini";

open(IN,"< $SETTING") || die "Setting file not found\n";
while(<IN>) {
	chomp;
	my ($c,$d) = split("=",$_);
	$c =~ s/[\x00-\x1f]//g; $c =~ s/^[ \t]+//; $c =~ s/[ \t]+$//;
	$d =~ s/[\x00-\x1f]//g; $d =~ s/^[ \t]+//; $d =~ s/[ \t]+$//;
	if ($c =~ /CoCoon_IP/)  { $CoCoon_IP  = $d; }
	if ($c =~ /STYLESHEET/) { $STYLESHEET = $d; }
	if ($c =~ /REQUEST/)    { $REQUEST    = $d; }
	if ($c =~ /LOCAL_PORT/) { $LOCAL_PORT = $d; }
}
close(IN);


# httpd
$proto=getprotobyname('tcp');
socket(ListenSock,PF_INET,SOCK_STREAM,$proto) || die("Can't open sokcetF$!\n");
bind(ListenSock,sockaddr_in($LOCAL_PORT,INADDR_ANY)) || die("Can't bindF$!\n");
listen(ListenSock,SOMAXCON);

while($sockaddr=accept(ConnectSock,ListenSock)){
	binmode(ConnectSock);
	select(ConnectSock); $|=1; select(STDOUT);
	$flg = 0;
	$req = "";
	while($flg==0) {
		$line = <ConnectSock>;
		$line =~ s/[\r\n]//g;
		if ($req eq "") { $req = $line; }
		if ($line eq "") { $flg = 1; }
	}
	
	# check request
	$xsl = $STYLESHEET;
	$xsl =~ s/\/([^\/]*)$/$1/;
	if (($req =~ /^GET +([^ ]*?) +/) || ($req =~ /^GET +([^ ]*?)$/)) {
		$req = $1;
		if ($req eq "/") {
			if ($pid != fork()) {
				print ConnectSock "HTTP/1.0 200 OK\r\n";
				&CCBrowse_mainout(ConnectSock);
				close(ConnectSock);
				exit;
			}
		} elsif ($req =~ /$xsl/) {
			print ConnectSock "HTTP/1.0 200 OK\r\n";
			&CCBrowse_xslout(ConnectSock);
			close(ConnectSock);
		} else {
			print ConnectSock "HTTP/1.0 404 Not found\r\n";
			print ConnectSock "Content-type: text/plain\r\n\r\n";
			print ConnectSock "404 Not found\r\n";
			close(ConnectSock);
		}
	} else {
		print ConnectSock "HTTP/1.0 400 Bad Request\r\n";
		print ConnectSock "Content-type: text/plain\r\n\r\n";
		print ConnectSock "400 Bad Request\r\n";
		close(ConnectSock);
	}
}
close(ListenSock);
exit;



sub CCBrowse_xslout {
	my $out = shift;

$stylesheet_body  = "";
open(STYLESHEET, "< $STYLESHEET") || die "open(STYLESHEET): $!\n";
$stylesheet_body .= $_  while(<STYLESHEET>);
close(STYLESHEET);

binmode $out;
print $out "Content-type: text/xml; charset=utf-8\n\n"  if( $CGIMODE );
print $out $stylesheet_body;
}


sub CCBrowse_mainout {
	my $out = shift;

$request_body  = "";
open(REQUEST, "< $REQUEST") || die "open(REQUEST): $!\n";
$request_body .= $_  while(<REQUEST>);
close(REQUEST);

binmode $out;
print $out "Content-type: text/xml; charset=utf-8\n\n"  if( $CGIMODE );
print $out <<"__XML1__";
<?xml version='1.0'?>
<?xml-stylesheet type="text/xsl" href="$STYLESHEET"?>

<items>
__XML1__

$StartingIndex = 0;
do {
	$proto = getprotobyname('tcp');
	$that = sockaddr_in($CoCoon_PORT, inet_aton($CoCoon_IP));
	socket(CoCoon, AF_INET, SOCK_STREAM, $proto) || die "socket(CoCoon): $!\n";
	binmode CoCoon;
	connect(CoCoon, $that) || die "connect(CoCoon): $!\n";
	select(CoCoon); $|=1; select(STDOUT);

	$request_body =~ s/>\d+<\/StartingIndex>/>$StartingIndex<\/StartingIndex>/;
	$content_length = length($request_body);
	$request_header = <<"__REQUEST_HEADER__";
POST /upnp/control/ContentDirectory HTTP/1.0
SOAPAction: "urn:schemas-upnp-org:service:ContentDirectory:1#Browse"
Content-Type: text/xml
Host: $CoCoon_IP:$CoCoon_PORT
Content-Length: $content_length
Pragma: no-cache
X-AV-Client-info: av = 2.0 ; cn = "test" ; mn = "CCBrowse"; mv = "0.0.2" ;
X-AV-Physical-Unit-Info: pa = "$HOSTNAME";
__REQUEST_HEADER__
	$request_header =~ s/\r//g;
	$request_header =~ s/\n/\r\n/g;

	#print STDERR $request_header . "\n";
	print CoCoon $request_header . "\r\n";
	print CoCoon $request_body;

	$content_length = 0;
	$unit_info = "";
	$response_header = "";
	while(<CoCoon>) {
		last  if( /^\r\n$/ );
		$response_header .= $_;
		$content_length = $1  if( /^Content-Length:\s*(\d+)/i );
		$unit_info = $1  if( /^X-AV-Physical-Unit-Info: pa = \"(.*)\"/i );
	}
	#print STDERR $response_header . "\n";
	read(CoCoon, $response_body, $content_length);
	close(CoCoon);

	$NumberReturned = 0;
	$TotalMatches = 0;
	$NumberReturned = $1  if( $response_body =~ /<NumberReturned>(\d+)<\/NumberReturned>/ );
	$TotalMatches = $1    if( $response_body =~ /<TotalMatches>(\d+)<\/TotalMatches>/ );

	$result = "";
	if( $response_body =~ /<Result>([\x00-\xff]*)<\/Result>/ ) {
		$result = $1;
		$result =~ s/\&lt;/\</g;
		$result =~ s/\&gt;/\>/g;
		$result =~ s/\&quot;/\"/g;
		$result =~ s/\&apos;/\'/g;
		$result =~ s/\&amp;/\&/g;
		$result =~ s/<\?xml[\x00-\xff]*\?>//;
	}
	print $out $result;

	$StartingIndex += $NumberReturned;

	#print STDERR "NumberReturned = $NumberReturned\n";
	#print STDERR "TotalMatches = $TotalMatches\n";
	#print STDERR "StartingIndex = $StartingIndex\n";

} while( $NumberReturned && ($StartingIndex < $TotalMatches)  );

print $out <<"__XML2__";
<unit_info>$unit_info</unit_info>
<http>
<request_header>$request_header</request_header>
<response_header>$response_header</response_header>
</http>
</items>
__XML2__
}
